diff --git a/libpurple/purplerequestfield.c b/libpurple/purplerequestfield.c
--- a/libpurple/purplerequestfield.c
+++ b/libpurple/purplerequestfield.c
@@ -23,6 +23,7 @@
 
 #include "glibcompat.h"
 #include "request.h"
+#include "request/purplerequestfieldstring.h"
 #include "debug.h"
 #include "purplekeyvaluepair.h"
 #include "purpleprivate.h"
@@ -41,13 +42,6 @@ typedef struct {
 
 	union {
 		struct {
-			gboolean multiline;
-			gboolean masked;
-			char *default_value;
-			char *value;
-		} string;
-
-		struct {
 			int default_value;
 			int value;
 			int lower_bound;
@@ -231,10 +225,7 @@ purple_request_field_finalize(GObject *o
 	g_free(priv->type_hint);
 	g_free(priv->tooltip);
 
-	if(priv->type == PURPLE_REQUEST_FIELD_STRING) {
-		g_free(priv->u.string.default_value);
-		g_free(priv->u.string.value);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_CHOICE) {
+	if(priv->type == PURPLE_REQUEST_FIELD_CHOICE) {
 		g_list_free_full(priv->u.choice.elements,
 		                 (GDestroyNotify)purple_key_value_pair_free);
 	} else if(priv->type == PURPLE_REQUEST_FIELD_LIST) {
@@ -587,14 +578,12 @@ gboolean
 purple_request_field_is_filled(PurpleRequestField *field) {
 	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
 
-	switch (purple_request_field_get_field_type(field))
-	{
-		case PURPLE_REQUEST_FIELD_STRING:
-			return (purple_request_field_string_get_value(field) != NULL &&
-				*(purple_request_field_string_get_value(field)) != '\0');
-		default:
-			return TRUE;
+	if(PURPLE_IS_REQUEST_FIELD_STRING(field)) {
+		PurpleRequestFieldString *sfield = PURPLE_REQUEST_FIELD_STRING(field);
+		return !purple_strempty(purple_request_field_string_get_value(sfield));
 	}
+
+	return TRUE;
 }
 
 void
@@ -684,117 +673,6 @@ purple_request_field_is_sensitive(Purple
 }
 
 PurpleRequestField *
-purple_request_field_string_new(const char *id, const char *text,
-							  const char *default_value, gboolean multiline)
-{
-	PurpleRequestField *field;
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(id   != NULL, NULL);
-	g_return_val_if_fail(text != NULL, NULL);
-
-	field = purple_request_field_new(id, text, PURPLE_REQUEST_FIELD_STRING);
-	priv = purple_request_field_get_instance_private(field);
-
-	priv->u.string.multiline = multiline;
-
-	purple_request_field_string_set_default_value(field, default_value);
-	purple_request_field_string_set_value(field, default_value);
-
-	return field;
-}
-
-void
-purple_request_field_string_set_default_value(PurpleRequestField *field,
-											const char *default_value)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING);
-
-	g_free(priv->u.string.default_value);
-	priv->u.string.default_value = g_strdup(default_value);
-}
-
-void
-purple_request_field_string_set_value(PurpleRequestField *field, const char *value)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING);
-
-	g_free(priv->u.string.value);
-	priv->u.string.value = g_strdup(value);
-}
-
-void
-purple_request_field_string_set_masked(PurpleRequestField *field, gboolean masked)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING);
-
-	priv->u.string.masked = masked;
-}
-
-const char *
-purple_request_field_string_get_default_value(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, NULL);
-
-	return priv->u.string.default_value;
-}
-
-const char *
-purple_request_field_string_get_value(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, NULL);
-
-	return priv->u.string.value;
-}
-
-gboolean
-purple_request_field_string_is_multiline(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, FALSE);
-
-	return priv->u.string.multiline;
-}
-
-gboolean
-purple_request_field_string_is_masked(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, FALSE);
-
-	return priv->u.string.masked;
-}
-
-PurpleRequestField *
 purple_request_field_int_new(const char *id, const char *text,
 	int default_value, int lower_bound, int upper_bound)
 {
@@ -1434,72 +1312,3 @@ purple_request_field_datasheet_get_sheet
 
 	return priv->u.datasheet.sheet;
 }
-
-/* -- */
-
-gboolean
-purple_request_field_email_validator(PurpleRequestField *field, gchar **errmsg,
-                                     G_GNUC_UNUSED gpointer user_data)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-	const char *value;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, FALSE);
-
-	value = purple_request_field_string_get_value(field);
-
-	if (value != NULL && purple_email_is_valid(value))
-		return TRUE;
-
-	if (errmsg)
-		*errmsg = g_strdup(_("Invalid email address"));
-	return FALSE;
-}
-
-gboolean
-purple_request_field_alphanumeric_validator(PurpleRequestField *field,
-	gchar **errmsg, void *allowed_characters)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-	const char *value;
-	gchar invalid_char = '\0';
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, FALSE);
-
-	value = purple_request_field_string_get_value(field);
-
-	g_return_val_if_fail(value != NULL, FALSE);
-
-	if (allowed_characters)
-	{
-		gchar *value_r = g_strdup(value);
-		g_strcanon(value_r, allowed_characters, '\0');
-		invalid_char = value[strlen(value_r)];
-		g_free(value_r);
-	}
-	else
-	{
-		while (value)
-		{
-			if (!g_ascii_isalnum(*value))
-			{
-				invalid_char = *value;
-				break;
-			}
-			value++;
-		}
-	}
-	if (!invalid_char)
-		return TRUE;
-
-	if (errmsg)
-		*errmsg = g_strdup_printf(_("Invalid character '%c'"),
-			invalid_char);
-	return FALSE;
-}
diff --git a/libpurple/purplerequestfield.c b/libpurple/request/purplerequestfieldstring.c
copy from libpurple/purplerequestfield.c
copy to libpurple/request/purplerequestfieldstring.c
--- a/libpurple/purplerequestfield.c
+++ b/libpurple/request/purplerequestfieldstring.c
@@ -22,158 +22,68 @@
 #include <glib/gi18n-lib.h>
 
 #include "glibcompat.h"
-#include "request.h"
-#include "debug.h"
-#include "purplekeyvaluepair.h"
-#include "purpleprivate.h"
-
-typedef struct {
-	PurpleRequestFieldType type;
-	PurpleRequestGroup *group;
-
-	char *id;
-	char *label;
-	char *type_hint;
+#include "purplerequestfield.h"
+#include "purplerequestfieldstring.h"
 
-	gboolean visible;
-	gboolean required;
-	gboolean sensitive;
-
-	union {
-		struct {
-			gboolean multiline;
-			gboolean masked;
-			char *default_value;
-			char *value;
-		} string;
-
-		struct {
-			int default_value;
-			int value;
-			int lower_bound;
-			int upper_bound;
-		} integer;
+struct _PurpleRequestFieldString {
+	PurpleRequestField parent;
 
-		struct {
-			gboolean default_value;
-			gboolean value;
-		} boolean;
-
-		struct {
-			gpointer default_value;
-			gpointer value;
-
-			GList *elements;
-		} choice;
-
-		struct {
-			GList *items;
-			gboolean has_icons;
-			GHashTable *item_data;
-			GList *selected;
-			GHashTable *selected_table;
-
-			gboolean multiple_selection;
-		} list;
-
-		struct {
-			unsigned int scale_x;
-			unsigned int scale_y;
-			char *buffer;
-			gsize size;
-		} image;
-
-		struct {
-			PurpleRequestDatasheet *sheet;
-		} datasheet;
-	} u;
-
-	void *ui_data;
-	char *tooltip;
-
-	PurpleRequestFieldValidator validator;
-	void *validator_data;
-} PurpleRequestFieldPrivate;
+	gboolean multiline;
+	gboolean masked;
+	char *default_value;
+	char *value;
+};
 
 enum {
 	PROP_0,
-	PROP_ID,
-	PROP_LABEL,
-	PROP_VISIBLE,
-	PROP_SENSITIVE,
-	PROP_TYPE_HINT,
-	PROP_TOOLTIP,
-	PROP_REQUIRED,
-	PROP_IS_VALIDATABLE,
+	PROP_MULTILINE,
+	PROP_MASKED,
+	PROP_DEFAULT_VALUE,
+	PROP_VALUE,
 	N_PROPERTIES,
 };
 static GParamSpec *properties[N_PROPERTIES] = {NULL, };
 
-G_DEFINE_TYPE_WITH_PRIVATE(PurpleRequestField, purple_request_field, G_TYPE_OBJECT)
-
 /******************************************************************************
  * Helpers
  *****************************************************************************/
 static void
-purple_request_field_set_id(PurpleRequestField *field, const char *id) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	priv = purple_request_field_get_instance_private(field);
-
-	g_free(priv->id);
-	priv->id = g_strdup(id);
+purple_request_field_string_set_multiline(PurpleRequestFieldString *field,
+                                          gboolean multiline)
+{
+	field->multiline = multiline;
 
-	g_object_notify_by_pspec(G_OBJECT(field), properties[PROP_ID]);
-}
-
-static void
-purple_request_field_set_field_type(PurpleRequestField *field,
-                                    PurpleRequestFieldType type)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	priv = purple_request_field_get_instance_private(field);
-
-	priv->type = type;
+	g_object_notify_by_pspec(G_OBJECT(field), properties[PROP_MULTILINE]);
 }
 
 /******************************************************************************
  * GObject Implementation
  *****************************************************************************/
+G_DEFINE_TYPE(PurpleRequestFieldString, purple_request_field_string,
+              PURPLE_TYPE_REQUEST_FIELD)
+
 static void
-purple_request_field_get_property(GObject *obj, guint param_id, GValue *value,
-                                  GParamSpec *pspec)
+purple_request_field_string_get_property(GObject *obj, guint param_id,
+                                         GValue *value, GParamSpec *pspec)
 {
-	PurpleRequestField *field = PURPLE_REQUEST_FIELD(obj);
+	PurpleRequestFieldString *field = PURPLE_REQUEST_FIELD_STRING(obj);
 
 	switch(param_id) {
-		case PROP_ID:
-			g_value_set_string(value, purple_request_field_get_id(field));
-			break;
-		case PROP_LABEL:
-			g_value_set_string(value, purple_request_field_get_label(field));
+		case PROP_MULTILINE:
+			g_value_set_boolean(value,
+			                    purple_request_field_string_is_multiline(field));
 			break;
-		case PROP_VISIBLE:
-			g_value_set_boolean(value, purple_request_field_is_visible(field));
-			break;
-		case PROP_SENSITIVE:
+		case PROP_MASKED:
 			g_value_set_boolean(value,
-			                    purple_request_field_is_sensitive(field));
+			                    purple_request_field_string_is_masked(field));
 			break;
-		case PROP_TYPE_HINT:
+		case PROP_DEFAULT_VALUE:
 			g_value_set_string(value,
-			                   purple_request_field_get_type_hint(field));
-			break;
-		case PROP_TOOLTIP:
-			g_value_set_string(value, purple_request_field_get_tooltip(field));
+			                   purple_request_field_string_get_default_value(field));
 			break;
-		case PROP_REQUIRED:
-			g_value_set_boolean(value,
-			                    purple_request_field_is_required(field));
-			break;
-		case PROP_IS_VALIDATABLE:
-			g_value_set_boolean(value,
-			                    purple_request_field_is_validatable(field));
+		case PROP_VALUE:
+			g_value_set_string(value,
+			                   purple_request_field_string_get_value(field));
 			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
@@ -182,36 +92,28 @@ purple_request_field_get_property(GObjec
 }
 
 static void
-purple_request_field_set_property(GObject *obj, guint param_id,
-                                  const GValue *value, GParamSpec *pspec)
+purple_request_field_string_set_property(GObject *obj, guint param_id,
+                                         const GValue *value,
+                                         GParamSpec *pspec)
 {
-	PurpleRequestField *field = PURPLE_REQUEST_FIELD(obj);
+	PurpleRequestFieldString *field = PURPLE_REQUEST_FIELD_STRING(obj);
 
 	switch(param_id) {
-		case PROP_ID:
-			purple_request_field_set_id(field, g_value_get_string(value));
+		case PROP_MULTILINE:
+			purple_request_field_string_set_multiline(field,
+			                                          g_value_get_boolean(value));
 			break;
-		case PROP_LABEL:
-			purple_request_field_set_label(field, g_value_get_string(value));
-			break;
-		case PROP_VISIBLE:
-			purple_request_field_set_visible(field,
-			                                 g_value_get_boolean(value));
+		case PROP_MASKED:
+			purple_request_field_string_set_masked(field,
+			                                       g_value_get_boolean(value));
 			break;
-		case PROP_SENSITIVE:
-			purple_request_field_set_sensitive(field,
-			                                   g_value_get_boolean(value));
+		case PROP_DEFAULT_VALUE:
+			purple_request_field_string_set_default_value(field,
+			                                              g_value_get_string(value));
 			break;
-		case PROP_TYPE_HINT:
-			purple_request_field_set_type_hint(field,
-			                                   g_value_get_string(value));
-			break;
-		case PROP_TOOLTIP:
-			purple_request_field_set_tooltip(field, g_value_get_string(value));
-			break;
-		case PROP_REQUIRED:
-			purple_request_field_set_required(field,
-			                                  g_value_get_boolean(value));
+		case PROP_VALUE:
+			purple_request_field_string_set_value(field,
+			                                      g_value_get_string(value));
 			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
@@ -220,160 +122,80 @@ purple_request_field_set_property(GObjec
 }
 
 static void
-purple_request_field_finalize(GObject *obj) {
-	PurpleRequestField *field = PURPLE_REQUEST_FIELD(obj);
-	PurpleRequestFieldPrivate *priv = NULL;
+purple_request_field_string_finalize(GObject *obj) {
+	PurpleRequestFieldString *field = PURPLE_REQUEST_FIELD_STRING(obj);
 
-	priv = purple_request_field_get_instance_private(field);
-
-	g_free(priv->id);
-	g_free(priv->label);
-	g_free(priv->type_hint);
-	g_free(priv->tooltip);
+	g_free(field->default_value);
+	g_free(field->value);
 
-	if(priv->type == PURPLE_REQUEST_FIELD_STRING) {
-		g_free(priv->u.string.default_value);
-		g_free(priv->u.string.value);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_CHOICE) {
-		g_list_free_full(priv->u.choice.elements,
-		                 (GDestroyNotify)purple_key_value_pair_free);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_LIST) {
-		g_list_free_full(priv->u.list.items,
-		                 (GDestroyNotify)purple_key_value_pair_free);
-		g_list_free_full(priv->u.list.selected, g_free);
-		g_hash_table_destroy(priv->u.list.item_data);
-		g_hash_table_destroy(priv->u.list.selected_table);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_DATASHEET) {
-		purple_request_datasheet_free(priv->u.datasheet.sheet);
-	} else if(priv->type == PURPLE_REQUEST_FIELD_IMAGE) {
-		g_free(priv->u.image.buffer);
-	}
+	G_OBJECT_CLASS(purple_request_field_string_parent_class)->finalize(obj);
+}
 
-	G_OBJECT_CLASS(purple_request_field_parent_class)->finalize(obj);
+static void
+purple_request_field_string_init(G_GNUC_UNUSED PurpleRequestFieldString *field)
+{
 }
 
 static void
-purple_request_field_init(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	priv = purple_request_field_get_instance_private(field);
-
-	priv->visible = TRUE;
-	priv->sensitive = TRUE;
-}
-
-static void
-purple_request_field_class_init(PurpleRequestFieldClass *klass) {
+purple_request_field_string_class_init(PurpleRequestFieldStringClass *klass) {
 	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
 
-	obj_class->finalize = purple_request_field_finalize;
-	obj_class->get_property = purple_request_field_get_property;
-	obj_class->set_property = purple_request_field_set_property;
+	obj_class->finalize = purple_request_field_string_finalize;
+	obj_class->get_property = purple_request_field_string_get_property;
+	obj_class->set_property = purple_request_field_string_set_property;
 
 	/**
-	 * PurpleRequestField:id:
+	 * PurpleRequestFieldString:multiline:
 	 *
-	 * The ID of the field.
+	 * Whether the field should allow multiline input.
 	 *
 	 * Since: 3.0.0
 	 */
-	properties[PROP_ID] = g_param_spec_string(
-		"id", "id",
-		"The ID of the field.",
-		NULL,
+	properties[PROP_MULTILINE] = g_param_spec_boolean(
+		"multiline", "multiline",
+		"Whether the field should allow multiline input.",
+		FALSE,
 		G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleRequestField:label:
+	 * PurpleRequestFieldString:masked:
 	 *
-	 * The label of the field.
+	 * Whether the field should be masked.
 	 *
 	 * Since: 3.0.0
 	 */
-	properties[PROP_LABEL] = g_param_spec_string(
-		"label", "label",
-		"The label of the field.",
+	properties[PROP_MASKED] = g_param_spec_boolean(
+		"masked", "masked",
+		"Whether the field should be masked.",
+		FALSE,
+		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
+
+	/**
+	 * PurpleRequestFieldString:default-value:
+	 *
+	 * The default value of the field.
+	 *
+	 * Since: 3.0.0
+	 */
+	properties[PROP_DEFAULT_VALUE] = g_param_spec_string(
+		"default-value", "default-value",
+		"The default value of the field.",
 		NULL,
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleRequestField:visible:
-	 *
-	 * Whether the field should be visible.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_VISIBLE] = g_param_spec_boolean(
-		"visible", "visible",
-		"Whether the field should be visible.",
-		TRUE,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:sensitive:
+	 * PurpleRequestFieldString:value:
 	 *
-	 * Whether the field should be sensitive.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_SENSITIVE] = g_param_spec_boolean(
-		"sensitive", "sensitive",
-		"Whether the field should be sensitive.",
-		TRUE,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:type-hint:
-	 *
-	 * The type hint of the field.
+	 * The value of the field.
 	 *
 	 * Since: 3.0.0
 	 */
-	properties[PROP_TYPE_HINT] = g_param_spec_string(
-		"type-hint", "type-hint",
-		"The type hint of the field.",
-		NULL,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:tooltip:
-	 *
-	 * The tooltip of the field.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_TOOLTIP] = g_param_spec_string(
-		"tooltip", "tooltip",
-		"The tooltip of the field.",
+	properties[PROP_VALUE] = g_param_spec_string(
+		"value", "value",
+		"The value of the field.",
 		NULL,
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
-	/**
-	 * PurpleRequestField:required:
-	 *
-	 * Whether the field is required to complete the request.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_REQUIRED] = g_param_spec_boolean(
-		"required", "required",
-		"Whether the field is required to complete the request.",
-		FALSE,
-		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleRequestField:is-validatable:
-	 *
-	 * Whether the field can be validated by the requestor.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_IS_VALIDATABLE] = g_param_spec_boolean(
-		"is-validatable", "is-validatable",
-		"Whether the field can be validated by the requestor.",
-		FALSE,
-		G_PARAM_READABLE | G_PARAM_STATIC_STRINGS);
-
 	g_object_class_install_properties(obj_class, N_PROPERTIES, properties);
 }
 
